source: client/engine/FileSystem.lib @ aab6c6e

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since aab6c6e was 8044615, checked in by ramon <ramongomez@…>, 11 years ago

#397: Mejorar rendimiento en detección de sistemas de archivos FAT en función ogGetFsType.

git-svn-id: https://opengnsys.es/svn/branches/version1.0@4306 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 33.4 KB
Line 
1#!/bin/bash
2#/**
3#@file    FileSystem.lib
4#@brief   Librería o clase FileSystem
5#@class   FileSystem
6#@brief   Funciones para gestión de sistemas de archivos.
7#@version 1.0.5
8#@warning License: GNU GPLv3+
9#*/
10
11
12#/**
13#         ogCheckFs int_ndisk int_nfilesys
14#@brief   Comprueba el estado de un sistema de archivos.
15#@param   int_ndisk      nº de orden del disco
16#@param   int_nfilesys   nº de orden del sistema de archivos
17#@return  (nada)
18#@exception OG_ERR_FORMAT    Formato incorrecto.
19#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
20#@exception OG_ERR_PARTITION Partición desconocida o no accesible.
21#@note    Requisitos: *fsck*
22#@warning No se comprueban sistemas de archivos montados o bloqueados.
23#@todo    Definir salidas.
24#@version 0.9 - Primera adaptación para OpenGnSys.
25#@author  Ramon Gomez, ETSII Universidad de Sevilla
26#@date    2009-10-07
27#@version 1.0.2 - Ignorar códigos de salida de comprobación (no erróneos).
28#@author  Ramon Gomez, ETSII Universidad de Sevilla
29#@date    2011-09-23
30#@version 1.0.4 - Soportar HFS/HFS+.
31#@author  Ramon Gomez, ETSII Universidad de Sevilla
32#@date    2012-05-21
33#@version 1.0.5 - Desmontar antes de comprobar, soportar Btrfs y ExFAT.
34#@author  Ramon Gomez, ETSII Universidad de Sevilla
35#@date    2012-09-05
36#*/ ##
37function ogCheckFs ()
38{
39# Variables locales.
40local PART TYPE PROG PARAMS CODES ERRCODE
41# Si se solicita, mostrar ayuda.
42if [ "$*" == "help" ]; then
43    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
44           "$FUNCNAME 1 1"
45    return
46fi
47
48# Error si no se reciben 2 parámetros.
49[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
50# Obtener partición.
51PART="$(ogDiskToDev $1 $2)" || return $?
52
53TYPE=$(ogGetFsType $1 $2)
54case "$TYPE" in
55    EXT[234])     PROG="e2fsck"; PARAMS="-y"; CODES=(1 2) ;;
56    BTRFS)        PROG="btrfsck"; CODES=1 ;;
57    REISERFS)     PROG="fsck.reiserfs"; PARAMS="<<<\"Yes\""; CODES=(1 2) ;;
58    REISER4)      PROG="fsck.reiser4"; PARAMS="-ay" ;;
59    JFS)          PROG="fsck.jfs"; CODES=(1 2) ;;
60    XFS)          PROG="fsck.xfs" ;;
61    NTFS)         PROG="ntfsfix" ;;
62    EXFAT)        PROG="fsck.exfat" ;;
63    FAT32)        PROG="dosfsck"; PARAMS="-a"; CODES=1 ;;
64    FAT16)        PROG="dosfsck"; PARAMS="-a"; CODES=1 ;;
65    FAT12)        PROG="dosfsck"; PARAMS="-a"; CODES=1 ;;
66    HFS)          PROG="fsck.hfs"; PARAMS="-f" ;;
67    HFSPLUS)      PROG="fsck.hfs"; PARAMS="-f" ;;
68    UFS)          PROG="fsck.ufs" ;;
69    *)            ogRaiseError $OG_ERR_PARTITION "$1, $2, $TYPE"
70                  return $? ;;
71esac
72# Error si el sistema de archivos esta montado o bloqueado.
73ogUnmount $1 $2
74if ogIsMounted $1 $2; then
75    ogRaiseError $OG_ERR_PARTITION "$1 $2"       # Indicar nuevo error
76    return $?
77fi
78if ogIsLocked $1 $2; then
79    ogRaiseError $OG_ERR_LOCKED "$1 $2"
80    return $?
81fi
82# Comprobar en modo uso exclusivo.
83ogLock $1 $2
84trap "ogUnlock $1 $2" 1 2 3 6 9
85eval $PROG $PARAMS $PART
86ERRCODE=$?
87case $ERRCODE in
88    0|${CODES[*]})
89            ERRCODE=0 ;;
90    127)    ogRaiseError $OG_ERR_NOTEXEC "$PROG"
91            ERRCODE=$OG_ERR_NOTEXEC ;;
92    *)      ogRaiseError $OG_ERR_PARTITION "$1 $2"
93            ERRCODE=$OG_ERR_PARTITION ;;
94esac
95ogUnlock $1 $2
96return $ERRCODE
97}
98
99
100#/**
101#         ogExtendFs int_ndisk int_nfilesys
102#@brief   Extiende un sistema de archivos al tamaño de su partición.
103#@param   int_ndisk      nº de orden del disco
104#@param   int_nfilesys   nº de orden del sistema de archivos
105#@return  (nada)
106#@exception OG_ERR_FORMAT   Formato incorrecto.
107#@exception OG_ERR_NOTFOUND Disco o particion no corresponden con un dispositivo.
108#@exception OG_ERR_PARTITION Partición desconocida o no accesible.
109#@note    Requisitos: *resize*
110#@version 0.1 -  Integracion para Opengnsys  -  EAC:   EnlargeFileSystem() en ATA.lib
111#@author  Antonio J. Doblas Viso. Universidad de Malaga
112#@date    2008-10-27
113#@version 0.9 - Primera adaptacion para OpenGnSys.
114#@author  Ramon Gomez, ETSII Universidad de Sevilla
115#@date    2009-09-23
116#@version 1.0.5 - Soporte para BTRFS.
117#@author  Ramon Gomez, ETSII Universidad de Sevilla
118#@date    2012-06-28
119#*/ ##
120function ogExtendFs ()
121{
122# Variables locales.
123local PART TYPE PROG PARAMS ERRCODE DOMOUNT
124
125# Si se solicita, mostrar ayuda.
126if [ "$*" == "help" ]; then
127    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
128           "$FUNCNAME 1 1"
129    return
130fi
131# Error si no se reciben 2 parámetros.
132[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
133
134# Obtener partición.
135PART="$(ogDiskToDev $1 $2)" || return $?
136
137# Redimensionar al tamano máximo según el tipo de partición.
138TYPE=$(ogGetFsType $1 $2)
139case "$TYPE" in
140    EXT[234])   PROG="resize2fs"; PARAMS="-f" ;;
141    BTRFS)      PROG="btrfs"; PARAMS="filesystem resize max"
142                DOMOUNT=1     # Debe estar montado.
143                ;;
144    REISERFS|REISER4)
145                PROG="resize_reiserfs"; PARAMS="-f" ;;
146    JFS)        ;;            # No se reduce (por el momento).
147    XFS)        ;;            # No se reduce (por el momento).
148    NTFS)       PROG="ntfsresize"; PARAMS="<<<\"y\" -f" ;;
149    EXFAT)      ;;            # No se reduce (por el momento).
150    FAT32|FAT16)  ;;          # No se reduce (probar "fatresize").
151    HFS|HFSPLUS)  ;;          # No se reduce (por el momento).
152    UFS)        ;;            # No se reduce (por el momento).
153    *)          ogRaiseError $OG_ERR_PARTITION "$1 $2 $TYPE"
154                return $? ;;
155esac
156# Salida normal si no se va a aplicar la operación.
157[ -z "$PROG" ] && return
158# Error si el sistema de archivos no se queda en el estado de montaje adecuado.
159if [ "$DOMOUNT" ]; then
160    PART=$(ogMount $1 $2) || return $?                      # Indicar nuevo error
161else
162    ogUnmount $1 $2 2>/dev/null
163    if ogIsMounted $1 $2; then
164         ogRaiseError $OG_ERR_PARTITION "$1 $2"             # Indicar nuevo error
165         return $?
166    fi
167fi
168# Error si el sistema de archivos está bloqueado.
169if ogIsLocked $1 $2; then
170    ogRaiseError $OG_ERR_LOCKED "$1 $2"
171    return $?
172fi
173# Redimensionar en modo uso exclusivo.
174ogLock $1 $2
175trap "ogUnlock $1 $2" 1 2 3 6 9
176eval $PROG $PARAMS $PART &>/dev/null
177ERRCODE=$?
178case $ERRCODE in
179    0)    ;;
180    127)  ogRaiseError $OG_ERR_NOTEXEC "$PROG"
181          ERRCODE=$OG_ERR_NOTEXEC ;;
182    *)    ogRaiseError $OG_ERR_PARTITION "$1 $2"
183          ERRCODE=$OG_ERR_PARTITION ;;
184esac
185ogUnlock $1 $2
186return $ERRCODE
187}
188
189
190#/**
191#         ogFormat int_ndisk int_nfilesys | CACHE
192#@see     ogFormatFs ogFormatCache
193#*/ ##
194function ogFormat ()
195{
196case "$*" in
197    CACHE|cache)  ogFormatCache ;;
198    *)            ogFormatFs "$@" ;;
199esac
200}
201
202
203#/**
204#         ogFormatFs int_ndisk int_nfilesys [type_fstype] [str_label]
205#@brief   Formatea un sistema de ficheros según el tipo de su partición.
206#@param   int_ndisk      nº de orden del disco
207#@param   int_nfilesys   nº de orden del sistema de archivos
208#@param   type_fstype    mnemónico de sistema de ficheros a formatear (opcional al reformatear)
209#@param   str_label      etiqueta de volumen (opcional)
210#@return  (por determinar)
211#@exception OG_ERR_FORMAT    Formato de ejecución incorrecto.
212#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
213#@exception OG_ERR_PARTITION Partición no accesible o desconocida.
214#@note    Requisitos:   mkfs*
215#@warning No formatea particiones montadas ni bloqueadas.
216#@todo    Definir salidas.
217#@version 0.9 - Primera versión para OpenGnSys.
218#@author  Ramon Gomez, ETSII Universidad de Sevilla
219#@date    2009-10-08
220#@version 1.0.4 - Solucionado error cuando no se detecta tipo de sistema de ficheros pero si se indica.
221#@author  Universidad de Huelva
222#@date    2012-04-11
223#@version 1.0.5 - Comprobar errores al inicio e independizar del tipo de tabla de particiones.
224#@author  Universidad de Huelva
225#@date    2013-05-16
226#*/ ##
227function ogFormatFs ()
228{
229# Variables locales
230local PART ID TYPE LABEL PROG PARAMS LABELPARAM ERRCODE
231
232# Si se solicita, mostrar ayuda.
233if [ "$*" == "help" ]; then
234    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys [str_label]" \
235           "$FUNCNAME 1 1" \
236           "$FUNCNAME 1 1 EXT4" \
237           "$FUNCNAME 1 1 \"DATA\"" \
238           "$FUNCNAME 1 1 EXT4 \"DATA\""
239    return
240fi
241# Error si no se reciben entre 2 y 4 parámetros.
242[ $# -ge 2 -a $# -le 4 ] || ogRaiseError $OG_ERR_FORMAT || return $?
243# Obtener fichero de dispositivo.
244PART="$(ogDiskToDev $1 $2)" || return $?
245# Error si la partición está montada o bloqueada.
246if ogIsMounted $1 $2; then
247    ogRaiseError $OG_ERR_PARTITION "$1 $2"       # Indicar nuevo error
248    return $?
249fi
250if ogIsLocked $1 $2; then
251    ogRaiseError $OG_ERR_LOCKED "$1 $2"
252    return $?
253fi
254# Si no se indica el tipo de sisitema de archivos, intentar obtenerlo.
255TYPE="${3:-$(ogGetFsType $1 $2)}"
256# Error, si no especifica el tipo de sistema de archivos a formatear.
257[ -n "$TYPE" ] || ogRaiseError $OG_ERR_FORMAT "$1 $2 ..." || return $?
258
259# Elegir tipo de formato.
260case "$TYPE" in
261    EXT2)         PROG="mkfs.ext2" ;;
262    EXT3)         PROG="mkfs.ext3" ;;
263    EXT4)         PROG="mkfs.ext4" ;;
264    BTRFS)        PROG="mkfs.btrfs" ;;
265    REISERFS)     PROG="mkfs.reiserfs"; PARAMS="-f"; LABELPARAM="-l" ;;
266    REISER4)      PROG="mkfs.reiser4"; PARAMS="-fy" ;;
267    XFS)          PROG="mkfs.xfs"; PARAMS="-f" ;;
268    JFS)          PROG="mkfs.jfs"; PARAMS="<<<\"y\"" ;;
269    LINUX-SWAP)   PROG="mkswap" ;;
270    NTFS)         PROG="mkntfs"; PARAMS="-f" ;;
271    EXFAT)        PROG="mkfs.exfat"; LABELPARAM="-n" ;;
272    FAT32)        PROG="mkdosfs"; PARAMS="-F 32"; LABELPARAM="-n" ;;
273    FAT16)        PROG="mkdosfs"; PARAMS="-F 16"; LABELPARAM="-n" ;;
274    FAT12)        PROG="mkdosfs"; PARAMS="-F 12"; LABELPARAM="-n" ;;
275    HFS)          PROG="mkfs.hfs" ;;
276    HFSPLUS)      PROG="mkfs.hfsplus"; LABELPARAM="-v" ;;
277    UFS)          PROG="mkfs.ufs"; PARAMS="-O 2" ;;
278    *)            ogRaiseError $OG_ERR_PARTITION "$1 $2 $TYPE"
279                  return $? ;;
280esac
281
282# Etiquetas de particion.
283if [ -z "$LABEL" ]; then
284    [ "$4" != "CACHE" ] || ogRaiseError $OG_ERR_FORMAT "$MSG_RESERVEDVALUE: CACHE" || return $?
285    [ -n "$4" ] && PARAMS="$PARAMS ${LABELPARAM:-"-L"} $4"
286else
287    PARAMS="$PARAMS ${LABELPARAM:-"-L"} $LABEL"
288fi
289
290# Formatear en modo uso exclusivo (desmontar siempre).
291ogLock $1 $2
292trap "ogUnlock $1 $2" 1 2 3 6 9
293umount $PART 2>/dev/null
294eval $PROG $PARAMS $PART 2>/dev/null
295ERRCODE=$?
296case $ERRCODE in
297    0)    ;;
298    127)  ogRaiseError $OG_ERR_NOTEXEC "$PROG" ;;
299    *)    ogRaiseError $OG_ERR_PARTITION "$1 $2" ;;
300esac
301ogUnlock $1 $2
302return $ERRCODE
303}
304
305
306#/**
307#         ogGetFsSize int_ndisk int_npartition [str_unit]
308#@brief Muestra el tamanio del sistema de archivos indicado, permite definir la unidad de medida, por defecto GB
309#@param   int_ndisk      nº de orden del disco
310#@param   int_npartition nº de orden de la partición
311#@param   str_unit       unidad (opcional, por defecto: KB)
312#@return  float_size - Tamaño del sistema de archivos
313#@note    str_unit = { KB, MB, GB, TB }
314#@exception OG_ERR_FORMAT   Formato incorrecto.
315#@exception OG_ERR_NOTFOUND Disco o partición no corresponden con un dispositivo.
316#@version 0.1 -  Integracion para Opengnsys  -  EAC:  SizeFileSystem() en FileSystem.lib
317#@author  Antonio J. Doblas Viso. Universidad de Malaga
318#@date    2008-10-27
319#@version 1.0.4 - Adaptación de las salidas.
320#@author  Ramon Gomez, ETSII Universidad de Sevilla
321#@date    2012-06-18
322#*/ ##
323function ogGetFsSize ()
324{
325# Variables locales.
326local MNTDIR UNIT VALUE FACTOR SIZE
327# Si se solicita, mostrar ayuda.
328if [ "$*" == "help" ]; then
329    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition [str_unit]" \
330           "$FUNCNAME 1 1  =>  15624188" \
331           "$FUNCNAME 1 1 KB  =>  15624188"
332    return
333fi
334# Error si no se reciben 2 o 3 parámetros.
335[ $# == 2 ] || [ $# == 3 ] || ogRaiseError $OG_ERR_FORMAT || return $?
336# Obtener unidad y factor de medida.
337UNIT="$3"
338UNIT=${UNIT:-"KB"}
339case "$UNIT" in
340    [kK]B)
341        FACTOR=1 ;;
342    MB) FACTOR=1024 ;;
343    GB) FACTOR=$[1024*1024] ;;
344    TB) FACTOR=$[1024*1024*1024] ;;
345    *)  ogRaiseError $OG_ERR_FORMAT "$3 != { KB, MB, GB, TB }"
346        return $? ;;
347esac
348
349# Obtener el tamaño del sistema de archivo (si no está formateado; tamaño = 0).
350MNTDIR="$(ogMount $1 $2 2>/dev/null)"
351if [ -n "$MNTDIR" ]; then
352    VALUE=$(df -BK "$MNTDIR" | awk '{getline; print $2}')
353    SIZE=$(echo "$VALUE $FACTOR" | awk '{printf "%f\n", $1/$2}')
354else
355    SIZE=0
356fi
357# Devolver el tamaño (quitar decimales si son 0).
358echo ${SIZE%.0*}
359}
360
361
362#/**
363#         ogGetFsType int_ndisk int_nfilesys
364#@brief   Devuelve el mnemonico con el tipo de sistema de archivos.
365#@param   int_ndisk      nº de orden del disco
366#@param   int_nfilesys   nº de orden del sistema de archivos
367#@return  Mnemonico
368#@note    Mnemonico: { EXT2, EXT3, EXT4, BTRFS, REISERFS, XFS, JFS, FAT12, FAT16, FAT32, NTFS, LINUX-SWAP, LINUX-LVM, LINUX-RAID, HFS, HFSPLUS, CACHE }
369#@exception OG_ERR_FORMAT   Formato incorrecto.
370#@exception OG_ERR_NOTFOUND Disco o particion no corresponden con un dispositivo.
371#@version 0.1 -  Integracion para Opengnsys  -  EAC:   TypeFS() en ATA.lib
372#@author  Antonio J. Doblas Viso. Universidad de Malaga
373#@date    2008-10-27
374#@version 0.9 - Primera adaptacion para OpenGnSys.
375#@author  Ramon Gomez, ETSII Universidad de Sevilla
376#@date    2009-07-21
377#@version 1.0.2 - Obtención de datos reales de sistemas de ficheros.
378#@author  Ramon Gomez, ETSII Universidad de Sevilla
379#@date    2011-12-02
380#@version 1.0.5 - Usar "blkid" para detectar tipo de sistema de archivo.
381#@author  Ramon Gomez, ETSII Universidad de Sevilla
382#@date    2014-06-10
383#*/ ##
384function ogGetFsType ()
385{
386# Variables locales.
387local PART ID TYPE
388# Si se solicita, mostrar ayuda.
389if [ "$*" == "help" ]; then
390    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
391           "$FUNCNAME 1 1  =>  NTFS"
392    return
393fi
394# Error si no se reciben 2 parámetros.
395[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
396
397# Detectar tipo de sistema de archivo (independientemente del tipo de partición).
398PART=$(ogDiskToDev "$1" "$2") || return $?
399TYPE=$(blkid -o export $PART | awk -F= '$1~/^TYPE/ { print toupper($2) }')
400
401# Componer valores correctos.
402case "$TYPE" in
403    EXT4)      # Comprobar si es caché o Ext4.
404               if [ "$1 $2" == "$(ogFindCache)" ]; then
405                   ogIsFormated $1 $2 2>/dev/null && TYPE="CACHE"
406               fi
407               ;;
408    VFAT)      TYPE="$(blkid -po export $PART | awk -F= '$1~/^VERSION$/ { print toupper($2) }')" ;;
409    SWAP)      TYPE="LINUX-SWAP" ;;
410    LVM*)      TYPE="LINUX-LVM" ;;
411    *RAID*)    TYPE="LINUX-RAID" ;;
412    *_MEMBER)  TYPE="${TYPE/_MEMBER/}" ;;
413esac
414
415[ -n "$TYPE" ] && echo "$TYPE"
416}
417
418
419#/**
420#         ogGetMountPoint int_ndisk int_nfilesys
421#@brief   Devuelve el punto de montaje de un sistema de archivos.
422#@param   int_ndisk      nº de orden del disco
423#@param   int_nfilesys   nº de orden del sistema de archivos
424#@return  Punto de montaje
425#@exception OG_ERR_FORMAT    Formato incorrecto.
426#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
427#@note    Requisitos: \c mount* \c awk
428#@version 0.9 - Primera versión para OpenGnSys.
429#@author  Ramon Gomez, ETSII Universidad de Sevilla
430#@date    2009-10-15
431#*/ ##
432function ogGetMountPoint ()
433{
434# Variables locales
435local PART
436# Si se solicita, mostrar ayuda.
437if [ "$*" == "help" ]; then
438    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
439           "$FUNCNAME 1 1  =>  /mnt/sda1"
440    return
441fi
442# Error si no se reciben 2 parámetros.
443[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
444# Obtener partición.
445PART="$(ogDiskToDev $1 $2)" || return $?
446
447mount | awk -v P=$PART '{if ($1==P) {print $3}}'
448}
449
450
451#/**
452#         ogIsFormated int_ndisk int_nfilesys
453#@brief   Comprueba si un sistema de archivos está formateado.
454#@param   int_ndisk      nº de orden del disco o volumen.
455#@param   int_nfilesys   nº de orden del sistema de archivos
456#@return  Código de salida: 0 - formateado, 1 - sin formato o error.
457#@version 0.91 - Adaptación inicial para comprobar que existe caché.
458#@author  Ramon Gomez, ETSII Universidad de Sevilla
459#@date    2010-03-18
460#@version 1.0.1 - Devolver falso en caso de error.
461#@author  Ramon Gomez, ETSII Universidad de Sevilla
462#@date    2011-05-18
463#@version 1.0.5 - Dejar de usar "parted".
464#@author  Ramon Gomez, ETSII Universidad de Sevilla
465#@date    2012-09-04
466#*/ ##
467function ogIsFormated ()
468{
469# Variables locales
470local DISK
471if [ "$*" == "help" ]; then
472    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
473           "if $FUNCNAME 1 1; then ... ; fi"
474    return
475fi
476# Falso, en caso de error.
477[ $# == 2 ] || return 1
478
479test -n "$(ogMount "$1" "$2" 2>/dev/null)"
480}
481
482
483#/**
484#         ogIsLocked int_ndisk int_npartition
485#@brief   Comprueba si una partición está bloqueada por una operación de uso exclusivo.
486#@param   int_ndisk      nº de orden del disco
487#@param   int_npartition nº de orden de la partición
488#@return  Código de salida: 0 - bloqueado, 1 - sin bloquear o error.
489#@note    El fichero de bloqueo se localiza en \c /var/lock/part, siendo \c part el dispositivo de la partición, sustituyendo el carácter "/" por "-".
490#@version 0.9 - Primera versión para OpenGnSys.
491#@author  Ramon Gomez, ETSII Universidad de Sevilla
492#@date    2009-09-03
493#@version 1.0.1 - Devolver falso en caso de error.
494#@author  Ramon Gomez, ETSII Universidad de Sevilla
495#@date    2011-05-18
496#*/ ##
497function ogIsLocked ()
498{
499# Variables locales
500local PART LOCKFILE
501
502# Si se solicita, mostrar ayuda.
503if [ "$*" == "help" ]; then
504    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
505           "if $FUNCNAME 1 1; then ... ; fi"
506    return
507fi
508# Falso, en caso de error.
509[ $# == 2 ] || return 1
510
511# Obtener partición.
512PART="$(ogDiskToDev $1 $2)" || return 1
513
514# Comprobar existencia del fichero de bloqueo.
515LOCKFILE="/var/lock/lock${PART//\//-}"
516test -f $LOCKFILE
517}
518
519
520#/**
521#         ogIsMounted int_ndisk int_nfilesys
522#@brief   Comprueba si un sistema de archivos está montado.
523#@param   int_ndisk      nº de orden del disco
524#@param   int_nfilesys   nº de orden del sistema de archivos
525#@return  Código de salida: 0 - montado, 1 - sin montar o error.
526#@version 0.9 - Primera versión para OpenGnSys.
527#@author  Ramon Gomez, ETSII Universidad de Sevilla
528#@date    2009-10-15
529#@version 1.0.1 - Devolver falso en caso de error.
530#@author  Ramon Gomez, ETSII Universidad de Sevilla
531#@date    2011-05-18
532#*/ ##
533function ogIsMounted ()
534{
535# Si se solicita, mostrar ayuda.
536if [ "$*" == "help" ]; then
537    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
538           "if $FUNCNAME 1 1; then ... ; fi"
539    return
540fi
541# Falso, en caso de error.
542[ $# == 2 ] || return 1
543
544test -n "$(ogGetMountPoint $1 $2)"
545}
546
547
548#/**
549#         ogIsWritable int_ndisk int_nfilesys
550#@brief   Comprueba si un sistema de archivos está montado de lectura y escritura.
551#@param   int_ndisk      nº de orden del disco
552#@param   int_nfilesys   nº de orden del sistema de archivos
553#@return  Código de salida: 0 - lectura y escritura, 1 - solo lectura o no montado.
554#@version 1.0.5 - Primera versión para OpenGnSys.
555#@author  Ramon Gomez, ETSII Universidad de Sevilla
556#@date    2013-10-09
557#/**
558function ogIsWritable ()
559{
560# Variables locales
561local PART
562
563# Si se solicita, mostrar ayuda.
564if [ "$*" == "help" ]; then
565    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_filesys" \
566           "if $FUNCNAME 1 1; then ... ; fi"
567    return
568fi
569# Falso, en caso de error.
570[ $# == 2 ] || return 1
571
572# Obtener partición.
573PART="$(ogDiskToDev $1 $2)" || return 1
574
575test -n "$(findmnt -n -o OPTIONS $PART | awk 'BEGIN {RS=","} /^rw$/ {print}')"
576}
577
578
579#/**
580#         ogLock int_ndisk int_npartition
581#@see     ogLockPartition
582#*/
583function ogLock ()
584{
585ogLockPartition "$@"
586}
587
588#/**
589#         ogLockPartition int_ndisk int_npartition
590#@brief   Genera un fichero de bloqueo para una partición en uso exlusivo.
591#@param   int_ndisk      nº de orden del disco
592#@param   int_npartition nº de orden de la partición
593#@return  (nada)
594#@exception OG_ERR_FORMAT    Formato incorrecto.
595#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
596#@note    El fichero de bloqueo se localiza en \c /var/lock/part, siendo \c part el dispositivo de la partición, sustituyendo el carácter "/" por "-".
597#@version 0.9 - Primera versión para OpenGnSys.
598#@author  Ramon Gomez, ETSII Universidad de Sevilla
599#@date    2009-09-03
600#*/ ##
601function ogLockPartition ()
602{
603# Variables locales
604local PART LOCKFILE
605
606# Si se solicita, mostrar ayuda.
607if [ "$*" == "help" ]; then
608    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
609           "$FUNCNAME 1 1"
610    return
611fi
612# Error si no se reciben 2 parámetros.
613[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
614
615# Obtener partición.
616PART="$(ogDiskToDev $1 $2)" || return $?
617
618# Crear archivo de bloqueo exclusivo.
619LOCKFILE="/var/lock/lock${PART//\//-}"
620touch $LOCKFILE
621}
622
623
624#/**
625#         ogMount int_ndisk int_nfilesys
626#@see     ogMountFs ogMountCache ogMountCdrom
627#*/ ##
628function ogMount ()
629{
630case "$*" in
631    CACHE|cache)
632        ogMountCache ;;
633    CDROM|cdrom)
634        ogMountCdrom ;;
635    *)  ogMountFs "$@" ;;
636esac
637}
638
639
640#/**
641#         ogMountFs int_ndisk int_nfilesys
642#@brief   Monta un sistema de archivos.
643#@param   int_ndisk      nº de orden del disco
644#@param   int_nfilesys   nº de orden del sistema de archivos
645#@return  Punto de montaje
646#@exception OG_ERR_FORMAT    Formato incorrecto.
647#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
648#@exception OG_ERR_PARTITION Tipo de particion desconocido o no se puede montar.
649#@version 0.1 -  Integracion para Opengnsys  -  EAC:   MountPartition() en FileSystem.lib
650#@author  Antonio J. Doblas Viso. Universidad de Malaga
651#@date    2008-10-27
652#@version 0.9 - Primera version para OpenGnSys.
653#@author  Ramon Gomez, ETSII Universidad de Sevilla
654#@date    2009-09-28
655#@version 1.0.5 - Independiente del tipo de sistema de ficheros.
656#@author  Ramon Gomez, ETSII Universidad de Sevilla
657#@date    2012-09-04
658#*/ ##
659function ogMountFs ()
660{
661# Variables locales
662local PART MNTDIR
663
664# Si se solicita, mostrar ayuda.
665if [ "$*" == "help" ]; then
666    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
667           "$FUNCNAME 1 1  =>  /mnt/sda1"
668    return
669fi
670# Error si no se reciben 2 parámetros.
671[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
672
673# Obtener partición.
674PART="$(ogDiskToDev "$1" "$2")" || return $?
675
676# Comprobar si el sistema de archivos ya está montada.
677MNTDIR="$(ogGetMountPoint $1 $2)"
678# Si no, montarlo en un directorio de sistema.
679if [ -z "$MNTDIR" ]; then
680    # Error si la particion esta bloqueada.
681    if ogIsLocked $1 $2; then
682        ogRaiseError $OG_ERR_LOCKED "$MSG_PARTITION, $1 $2"
683        return $?
684    fi
685    # Crear punto de montaje o enlace simbólico para caché local.
686    MNTDIR=${PART/dev/mnt}
687    if [ "$(ogFindCache)" == "$1 $2" -a -n "$OGCAC" ]; then
688        mkdir -p $OGCAC
689        ln -fs $OGCAC $MNTDIR
690    else
691        mkdir -p $MNTDIR
692    fi
693    # Montar sistema de archivos.
694    mount $PART $MNTDIR &>/dev/null || \
695               mount $PART $MNTDIR -o force,remove_hiberfile &>/dev/null || \
696               ogRaiseError $OG_ERR_PARTITION "$1, $2" || return $?
697fi
698echo "$MNTDIR"
699}
700
701
702#####  PRUEBAS
703# Montar CDROM
704function ogMountCdrom ()
705{
706local DEV MNTDIR
707DEV="/dev/cdrom"            # Por defecto
708MNTDIR=$(mount | awk -v D=$DEV '{if ($1==D) {print $3}}')
709if [ -z "$MNTDIR" ]; then
710    MNTDIR=${DEV/dev/mnt}
711    mkdir -p $MNTDIR
712    mount -t iso9660 $DEV $MNTDIR || ogRaiseError $OG_ERR_PARTITION "cdrom" || return $?
713fi
714echo $MNTDIR
715}
716
717
718#/**
719#         ogReduceFs int_ndisk int_nfilesys
720#@brief   Reduce el tamaño del sistema de archivos, sin tener en cuenta el espacio libre.
721#@param   int_ndisk      nº de orden del disco
722#@param   int_nfilesys   nº de orden del sistema de archivos
723#@return  int_tamañoKB - tamaño en KB
724#@exception OG_ERR_FORMAT    Formato incorrecto.
725#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
726#@exception OG_ERR_PARTITION Partición desconocida o no accesible.
727#@warning En Windows, se borran los ficheros de hiberanción y de paginación.
728#@warning El sistema de archivos se amplía al mínimo + 10%.
729#@note    Requisitos:   *resize*
730#@version 0.1 -  Integracion para Opengnsys  -  EAC:   ReduceFileSystem() en ATA.lib
731#@author  Antonio J. Doblas Viso. Universidad de Malaga
732#@date    2008-10-27
733#@version 0.9 - Primera version para OpenGnSys.
734#@author  Ramon Gomez, ETSII Universidad de Sevilla
735#@date    2009-09-23
736#@version 0.9.2 - Añadir un 10% al tamaño mínimo requerido.
737#@author  Ramon Gomez, ETSII Universidad de Sevilla
738#@date    2010-09-27
739#@version 1.0 -  Deteccion automatica del tamaño minimo adecuado
740#@author  Antonio J. Doblas Viso. Universidad de Malaga
741#@date    2011-02-24
742#*/ ##
743function ogReduceFs ()
744{
745# Variables locales
746local PART BLKS SIZE
747
748# Si se solicita, mostrar ayuda.
749if [ "$*" == "help" ]; then
750    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_nfilesys" \
751           "$FUNCNAME 1 1"
752    return
753fi
754# Error si no se reciben 2 parámetros.
755[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
756
757# Obtener partición.
758PART="$(ogDiskToDev $1 $2)" || return $?
759
760# Redimensionar según el tipo de particion.
761case "$(ogGetFsType $1 $2)" in
762    EXT[234])
763        ogUnmount $1 $2 2>/dev/null
764        # Ext2/3/4: Tamaño de los bloques del sistema de archivos
765        BLKS=$(tune2fs -l $PART | awk '/Block size/ {print int($3/512)}')
766        # Traduce el num. en sectores de 512B a tamano en MB.
767        #SIZE=$(resize2fs -P $PART 2>/dev/null | \
768                #       awk -v B=$BLKS '/minimum size/ {print int($7*1.1*B/2048)}')
769        #resize2fs -fp $PART "${SIZE}M" &>/dev/null || ogRaiseError $OG_ERR_PARTITION "$1,$2" || return $?
770        resize2fs -fpM $PART  &>/dev/null || ogRaiseError $OG_ERR_PARTITION "$1,$2" || return $?
771        ;;
772    BTRFS)
773        MNTDIR=$(ogMount $1 $2)
774        # Calcular tamaño ocupado + 10%.
775        SIZE=$[ $(df -k $MNTDIR | awk '{getline;print $3}') * 110 / 100 ]
776        btrfs filesystem resize ${SIZE}k $MNTDIR
777        ;;
778    REISERFS|REISER4)
779        MNTDIR=$(ogMount $1 $2)
780        # Calcular tamaño ocupado + 10%.
781        SIZE=$[ $(df -k $MNTDIR | awk '{getline;print $3}') * 110 / 100 ]
782        ogUnmount $1 $2 2>/dev/null
783        resize_reiserfs -s${SIZE}K $PART
784        ;;
785    JFS)    ;;          # No se reduce (por el momento).
786    XFS)    ;;          # No se reduce (por el momento).
787    NTFS)
788        # Borrar ficheros de hibernación y paginación de Windows.
789        ogDeleteFile $1 $2 hiberfil.sys 2>/dev/null
790        ogDeleteFile $1 $2 pagefile.sys 2>/dev/null
791        ogDeleteFile $1 $2 swapfile.sys 2>/dev/null
792        ogUnmount $1 $2 2>/dev/null
793        ## NTFS: Obtiene tamaño mínimo en MB.
794        #SIZE=$(ntfsresize -fi $PART | awk '/resize at/ {print int($8*1.1)}')
795        #ntfsresize -fns "${SIZE}M" $PART >/dev/null || ogRaiseError $OG_ERR_PARTITION "$1,$2" || return $?
796        #ntfsresize -fs "${SIZE}M" $PART <<<"y" >/dev/null || ogRaiseError $OG_ERR_PARTITION "$1,$2" || return $?
797        SIZE=$(ogReduceFsCheck $1 $2)
798        [ "$SIZE" == 0 ] && return 1   
799        ntfsresize -fs "${SIZE}M" $PART <<<"y"  || ogRaiseError $OG_ERR_PARTITION "error reduciendo $1,$2" || return $?
800        ;;
801    EXFAT)  ;;          # No se reduce (por el momento).
802    FAT32|FAT16)  ;;    # No se reduce (probar "fatresize").
803    HFS|HFSPLUS)  ;;    # No se reduce (por el momento).
804    UFS)    ;;          # No se reduce (por el momento).
805    *)  ogRaiseError $OG_ERR_PARTITION "$1,$2"
806        return $? ;;
807esac
808ogGetFsSize $1 $2
809}
810
811
812function ogReduceFsCheck ()
813{
814#IMPORTANTE: retorna el valor en MB que podrá reducir el FS de una particion ntfs
815#valor devuelto 0, y codigo error 1. No se puede reducir, probar a reiniciar windows y chkdsk
816
817
818local  PART RC MODE SIZE SIZEDATA
819[ $# == 2 ] && MODE=STAGE1
820[ $# == 3 ] && MODE=STAGE2
821[ -z $MODE ] && return
822
823PART="$(ogDiskToDev $1 $2)" || return $?
824ogUnmount $1 $2 &>/dev/null
825
826
827case $MODE in
828        STAGE1)
829        #       echo "primera etapa $*"
830                # Mostramos el error
831                #ntfsresize -fi $PART &>/dev/null
832                ntfsresize -fi $PART | grep -A 10 -e ERROR >&2
833                RC=`echo $?`
834        #       echo "RC es" $RC
835                # if [ "$RC" -eq "1" ] # con error la salida del grep es 0
836                if [ "$RC" -eq "0" ]
837                then
838                        echo "0"
839                        return 1       
840                fi 
841                SIZEDATA=$(ntfsresize -fi $PART | awk '/resize at/ {print $8+1000}')
842        #       echo "salida" $?
843        #       echo $SIZEDATA
844                ogReduceFsCheck $1 $2 $SIZEDATA
845                return 0
846       ;;
847        STAGE2)
848        #       echo "segunda etapa $*"
849                SIZEDATA=$3
850                ntfsresize -fns "${SIZEDATA}M" $PART &>/tmp/ntfsresize.txt
851                RC=$?
852                if [ "$RC" == "0" ]
853                then 
854                        SIZE=$SIZEDATA 
855                        echo $SIZE     
856                else
857                        SIZEEXTRA=$(cat /tmp/ntfsresize.txt | awk '/Needed relocations :/ {print $0}' | awk -F"(" '{print $2}' | awk '{print $1+500}')
858                        SIZE=$(expr $SIZEDATA + $SIZEEXTRA)
859                        ogReduceFsCheck $1 $2 $SIZE
860                        return 0
861                fi
862        ;;
863        *)
864        return
865        ;;
866esac
867}
868
869
870
871#/**
872#         ogUnlock int_ndisk int_npartition
873#@see     ogUnlockPartition
874#*/ ##
875function ogUnlock ()
876{
877ogUnlockPartition "$@"
878}
879
880#/**
881#         ogUnlockPartition int_ndisk int_npartition
882#@brief   Elimina el fichero de bloqueo para una particion.
883#@param   int_ndisk      nº de orden del disco
884#@param   int_npartition nº de orden de la partición
885#@return  (nada)
886#@exception OG_ERR_FORMAT    Formato incorrecto.
887#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
888#@note    El fichero de bloqueo se localiza en \c /var/lock/part, siendo \c part el dispositivo de la partición, sustituyendo el carácter "/" por "-".
889#@version 0.9 - Primera versión para OpenGnSys.
890#@author  Ramon Gomez, ETSII Universidad de Sevilla
891#@date    2009-09-03
892#*/ ##
893function ogUnlockPartition ()
894{
895# Variables locales
896local PART LOCKFILE
897
898# Si se solicita, mostrar ayuda.
899if [ "$*" == "help" ]; then
900    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" \
901           "$FUNCNAME 1 1"
902    return
903fi
904# Error si no se reciben 2 parámetros.
905[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
906
907# Obtener partición.
908PART="$(ogDiskToDev $1 $2)" || return $?
909
910# Borrar archivo de bloqueo exclusivo.
911LOCKFILE="/var/lock/lock${PART//\//-}"
912rm -f $LOCKFILE
913}
914
915
916#/**
917#         ogUnmount int_ndisk int_npartition
918#@see     ogUnmountFs
919#*/ ##
920function ogUnmount ()
921{
922ogUnmountFs "$@"
923}
924
925#/**
926#         ogUnmountFs int_ndisk int_nfilesys
927#@brief   Desmonta un sistema de archivos.
928#@param   int_ndisk      nº de orden del disco
929#@param   int_nfilesys   nº de orden del sistema de archivos
930#@return  Nada
931#@exception OG_ERR_FORMAT    Formato incorrecto.
932#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
933#@warning La partición no está previamente montada o no se puede desmontar.
934#@version 0.1 -  Integracion para Opengnsys  -  EAC:  UmountPartition() en FileSystem.lib
935#@author  Antonio J. Doblas Viso. Universidad de Malaga
936#@date    2008-10-27
937#@version 0.9 - Primera version para OpenGnSys.
938#@author  Ramon Gomez, ETSII Universidad de Sevilla
939#@date    2009-09-28
940#*/ ##
941function ogUnmountFs ()
942{
943# Variables locales
944local PART MNTDIR
945
946# Si se solicita, mostrar ayuda.
947if [ "$*" == "help" ]; then
948    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk int_npartition" "$FUNCNAME 1 1"
949    return
950fi
951# Error si no se reciben 2 parámetros.
952[ $# == 2 ] || ogRaiseError $OG_ERR_FORMAT || return $?
953
954# Obtener partición y punto de montaje.
955PART="$(ogDiskToDev $1 $2)" || return $?
956MNTDIR="$(ogGetMountPoint $1 $2)"
957
958# Si está montada, desmontarla.
959if [ -n "$MNTDIR" ]; then
960    # Error si la particion está bloqueada.
961    if ogIsLocked $1 $2; then
962        ogRaiseError $OG_ERR_LOCKED "$MSG_PARTITION $1, $2"
963        return $?
964    fi
965    # Desmontar y borrar punto de montaje.
966    umount $PART 2>/dev/null || ogEcho warning "$FUNCNAME: $MSG_DONTUNMOUNT: \"$1, $2\""
967    rmdir $MNTDIR 2>/dev/null || rm -f $MNTDIR 2>/dev/null
968else
969    ogEcho warning "$MSG_DONTMOUNT: \"$1,$2\""
970fi
971}
972
973
974#/**
975#         ogUnmountAll int_ndisk
976#@brief   Desmonta todos los sistema de archivos de un disco, excepto el caché local.
977#@param   int_ndisk      nº de orden del disco
978#@return  Nada
979#@exception OG_ERR_FORMAT    Formato incorrecto.
980#@exception OG_ERR_NOTFOUND  Disco o particion no corresponden con un dispositivo.
981#@warning No se desmonta la partición marcada como caché local.
982#@version 0.9 - Versión para OpenGnSys.
983#@author  Ramon Gomez, ETSII Universidad de Sevilla
984#@date    2009/10/07
985#*/ ##
986function ogUnmountAll ()
987{
988# Variables locales
989local DISK PART
990# Si se solicita, mostrar ayuda.
991if [ "$*" == "help" ]; then
992    ogHelp "$FUNCNAME" "$FUNCNAME int_ndisk" "FUNCNAME 1"
993    return
994fi
995# Error si no se recibe 1 parámetro.
996[ $# == 1 ] || ogRaiseError $OG_ERR_FORMAT || return $?
997
998# Obtener partición y punto de montaje.
999DISK="$(ogDiskToDev $1)" || return $?
1000for ((PART=1; PART<=$(ogGetPartitionsNumber $1); PART++)); do
1001    case "$(ogGetFsType $1 $PART)" in
1002        CACHE) ;;
1003        *)     ogUnmount $1 $PART 2>/dev/null ;;
1004    esac
1005done
1006}
1007
1008
1009# AVISO:  Componer corretcamente esta función.
1010function ogGetFreeSize () {
1011local particion unit factor valor
1012if [ $# = 0 ]
1013then
1014        echo "sintaxis: ogGetFreeSize int_disco int_partition str_SizeOutput [ kB MB GB -default GB]-]" red
1015        echo "devuelve int_size : int_data : int_free" red
1016return
1017fi
1018if [ $# -ge 2 ]
1019then
1020        particion=`ogMount $1 $2 ` #1>/dev/null 2>&1
1021        if [ -z $3 ]
1022                then
1023                        unit=kB  # s B kB MB GB TB %
1024                else
1025                        unit=$3
1026        fi
1027        case $unit in
1028                kB)
1029                        factor="1.024";
1030                        #valor=`df | grep  $particion | awk -F" " '{size=$2*1.024; used=$3*1.024; free=$4*1.024; printf "%d:%d:%d", size,used,free}'`
1031                        valor=`df | grep  $particion | awk -F" " '{size=$2*1.024; used=$3*1.024; free=$4*1.024; printf "%d", free}'`
1032                        ;;
1033                MB)
1034                        factor="1.024/1000";
1035                        valor=`df | grep  $particion | awk -F" " '{size=$2*1.024/1000; used=$3*1.024/1000; free=$4*1.024/1000; printf "%d:%d:%d", size,used,free}'`
1036                ;;
1037                GB)
1038                        factor="1.024/1000000";
1039                        valor=`df | grep $particion | awk -F" " '{size=$2*1.024/1000000; used=$3*1.024/1000000; free=$4*1.024/1000000; printf "%f:%f:%f", size,used,free}'`
1040                ;;
1041        esac
1042        #echo $valor
1043        #NumberRound $valor
1044        #valor=`NumberRound $valor`;
1045        echo $valor
1046fi
1047}
1048
Note: See TracBrowser for help on using the repository browser.